//
//  ViewController.swift
//  SwiftId
//
//  Created by Martin Bateson on 12/5/14.
//  Copyright (c) 2014 Pleiades Apps. All rights reserved.
//

import UIKit
import LocalAuthentication

class ViewController: UIViewController,UIAlertViewDelegate {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


    @IBAction func myButton(sender: AnyObject) {
        
        
        let authorization = LAContext()
        let authPolicy = LAPolicy.DeviceOwnerAuthenticationWithBiometrics
        
        
        var authorizationError: NSErrorPointer = nil
        
        
        if(authorization.canEvaluatePolicy(authPolicy, error: authorizationError)){
            // if device is touch id capable do something here
            
            authorization.evaluatePolicy(authPolicy, localizedReason: "Touch the fingerprint sensor", reply: {(success:Bool,error:NSError?) in
                
                dispatch_async(dispatch_get_main_queue(),{
                if(success){
                    self.performSegueWithIdentifier("toMain", sender: nil)
                    println("touching")
                }else {
                    println(error!.code)
                    if(error!.code == -2){
                        println("user touched cancel")}
                    if(error!.code == -3){
                        println("User touched password")
                        // do something here
                        self.userPasswordRequest()
                        
                    }
                    
                }
                    
                })
            })
            
        }
        else{
            // add alert
            println("Not Touch ID Capable")
            self.noTouchIDonThisDeviceAlert()
        }
        
        
    }
    
    func userPasswordRequest() {
        var passwordAlert : UIAlertView = UIAlertView(title: "Swift Touch ID", message: "Enter a password", delegate: self, cancelButtonTitle: "Cancel", otherButtonTitles: "Okay")
        passwordAlert.alertViewStyle = UIAlertViewStyle.SecureTextInput
        passwordAlert.show()
    }
    
    func noTouchIDonThisDeviceAlert() {
        var noTouchAlert : UIAlertView = UIAlertView(title: "Touch ID not Available", message: "Sorry", delegate: self, cancelButtonTitle: "Okay")
        
        noTouchAlert.show()
    }
    func alertView(alertView: UIAlertView!, clickedButtonAtIndex buttonIndex: Int) {
        if buttonIndex == 1 {
            if !alertView.textFieldAtIndex(0)!.text.isEmpty {
                if alertView.textFieldAtIndex(0)!.text == "love" {
                    self.performSegueWithIdentifier("toMain", sender: nil)
                    println("Hey it worked")
                }
                else{
                    userPasswordRequest()
                }
            }
            else{
                userPasswordRequest()
            }
        }
    }
    
}

